;; sum of range 1 to (not including) 50
(define (easy1)
  (sum (range 1 50)))

;; sum of even numbers in range 1 to 50
(define (easy2)
  (sum (filter even?  (range 1 50))))

;; sum of all numbers in range 1 to 50 divisible by 3
(define (easy3)
  (apply + (filter (lambda (x) (divisible? x 3))
                   (range 1 50))))

;; project euler problem 1
;; sum of all numbers below 1000 divisible by 3 or 5
(define (prob1)
  (sum (filter (lambda (i)
                     (or (divisible? i 3)
                         (divisible? i 5)))
                   (range 1 1000))))

;; project euler problem 2
;; sum of all even fibonacci numbers below 4000000
(define (fib-range-to lim)
  (define (fib a b)
    (if (< b lim)
        (cons a (fib b (+ a b)))
        (cons a '())))
  (fib 1 1))

(define (prob2)
  (sum (filter even? (fib-range-to 4000000))))

(define (run-tests)
  (define (print-result res got expected)
    (print (list res
                 'got got
                 'expected expected
                 'ok: (= got expected))))
  (let ((e1 (easy1))
        (e2 (easy2))
        (e3 (easy3))
        (ans1 (prob1))
        (ans2 (prob2)))
    (print '(RUNNING TESTS:))
    (print-result 'easy1 e1 1225)
    (print-result 'easy2 e2 600)
    (print-result 'easy3 e3 408)
    (print-result 'prob1 ans1 233168)
    (print-result 'prob2 ans2 4613732)))

(run-tests)
