datatype lexresult= EOF| SYMBOL of string | LPAREN |
  NUM of int | RPAREN | QUOTE | BOOL of bool | D;

fun error (x) = print (x ^ "\n");
val eof = fn () => EOF

local

    fun getVal(c) = ord(c) - ord(#"0");

    fun charlToInt (nil, r)   = 0
      | charlToInt (hd::tl, r) = getVal(hd) * r + charlToInt(tl, r*10);
in
fun toInt (s) = charlToInt(rev(explode(s)), 1)
end;

%%
%structure LispTokens
digit=[0-9];
operator=[-/+*=<>];
symbol=[a-zA-Z]([a-zA-Z0-9]|[!$%&*+-./:<=>?@^_~])*;
              comment=";".*"\n";
ws = [\ \t\n];
%%
{comment} => (lex()); 
{ws}+    => (lex());
"("      => (LPAREN);
")"      => (RPAREN);
"'"      => (QUOTE);
"."      => (D);
"true"   => (BOOL(true));
"false"   => (BOOL(false));
{digit}+ => (NUM (toInt(yytext)));
{symbol}+ => (SYMBOL(yytext));
{operator} => (SYMBOL(yytext));
.        => (error ("lexer: ignoring bad character "^yytext); lex());
