(define (list . l)
  l)

(define (apply f l)
  (eval (cons f l)))

(define (k l m)
  (if (= l m) (+ l m) (- l m)))

(define (map f l)
  (if (null? l)
      '()
      (cons (f (car l))
            (map f (cdr l)))))

(define (inc n)
  (+ n 1))

(define (dec n)
  (- n 1))

;; get last element
(define (last l)
  (if (null? (cdr l))
      (car l)
      (last (cdr l))))

(define (append a b)
  (if (null? a)
      b
      (if (null? (cdr a))
          (cons (car a) b)
          (cons (car a)
                (append (cdr a) b)))))

(define (reverse l)
  (if (pair? l)
      (append (reverse (cdr l)) 
              (list (car l)))
      '()))

;; flattens a list
(define (fringe x)
  (if (pair? x)
      (append (fringe (car x))
              (fringe (cdr x)))
      (if (null? x)
          x
          (list x))))

;; sadly no difference between pairs and lists
(define (list? l)
  (pair l))

(define (filter p l)
  (cond ((null? l) '())
        ((p (car l)) (cons (car l)
                           (filter p (cdr l))))
        (true (filter p (cdr l)))))

(define (not k)
  (if k
      false
      true))

(define (odd? i)
  (= (remainder i 2) 1))

(define (even? i)
  (not (odd? i)))

(define (zero? i)
  (= i 0))

(define (divisible? i k)
  (= (remainder i k) 0))

(define (range start lim)
  (define (l i)
    (if (< i lim)
        (cons i (l (+ i 1)))
        '()))
  (l start))

(define (filter p l)
  (cond ((null? l) '())
        ((p (car l)) (cons (car l)
                           (filter p (cdr l))))
        (true (filter p (cdr l)))))

(define (sum l)
  (apply + l))